<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "scan_error_log".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "ScanErrorLog".
 *
 * Columns in table "scan_error_log" available as properties of the model,
 * followed by relations of table "scan_error_log" available as properties of the model.
 *
 * @property integer $id
 * @property integer $scan_error_id
 * @property string $scan_error_detail_id
 * @property string $status_id
 * @property string $type_id
 * @property string $comment
 * @property integer $added_by_account_id
 * @property string $date_added
 *
 * @property ScanError $scanError
 * @property Account $addedByAccount
 * @property Status $status
 * @property Type $type
 * @property ScanErrorDetail $scanErrorDetail
 */
abstract class BaseScanErrorLog extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'scan_error_log';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'ScanErrorLog|ScanErrorLogs', $n);
    }

    public static function representingColumn()
    {
        return 'comment';
    }

    public function rules()
    {
        return array(
            array('scan_error_id', 'required'),
            array('scan_error_id, added_by_account_id', 'numerical', 'integerOnly'=>true),
            array('scan_error_detail_id, status_id, type_id', 'length', 'max'=>10),
            array('comment', 'length', 'max'=>255),
            array('date_added', 'safe'),
            array('scan_error_detail_id, status_id, type_id, comment, added_by_account_id, date_added', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, scan_error_id, scan_error_detail_id, status_id, type_id, comment, added_by_account_id, date_added', 'safe', 'on'=>'search'),
        );
    }

    public function relations()
    {
        return array(
            'scanError' => array(self::BELONGS_TO, 'ScanError', 'scan_error_id'),
            'addedByAccount' => array(self::BELONGS_TO, 'Account', 'added_by_account_id'),
            'status' => array(self::BELONGS_TO, 'Status', 'status_id'),
            'type' => array(self::BELONGS_TO, 'Type', 'type_id'),
            'scanErrorDetail' => array(self::BELONGS_TO, 'ScanErrorDetail', 'scan_error_detail_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'scan_error_id' => null,
            'scan_error_detail_id' => null,
            'status_id' => null,
            'type_id' => null,
            'comment' => Yii::t('app', 'Comment'),
            'added_by_account_id' => null,
            'date_added' => Yii::t('app', 'Date Added'),
            'scanError' => null,
            'addedByAccount' => null,
            'status' => null,
            'type' => null,
            'scanErrorDetail' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('scan_error_id', $this->scan_error_id);
        $criteria->compare('scan_error_detail_id', $this->scan_error_detail_id);
        $criteria->compare('status_id', $this->status_id);
        $criteria->compare('type_id', $this->type_id);
        $criteria->compare('comment', $this->comment, true);
        $criteria->compare('added_by_account_id', $this->added_by_account_id);
        $criteria->compare('date_added', $this->date_added, true);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria, 'pagination' => array('pageSize' => 100)
        ));
    }

}
